/* Copyright (C) 2007 GFRN systems

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   The latest version of this program may be found at
   http://CQiNet.sourceforge.net

   $Log: ToneGen.h,v $
   Revision 1.3  2008/04/11 14:13:51  wb6ymh
   Added support for "FILE" and "DTMF" tags.

   Revision 1.2  2008/03/18 20:06:03  wb6ymh
   Added support for sending CW from a tone spec.

   Revision 1.1  2007/12/01 06:40:59  wb6ymh
   Inital import - general purpose tone generator class.


*/

#ifndef _TONEGEN_H_
#define _TONEGEN_H_

class CToneGen
{
public:
   CToneGen();
   ~CToneGen();
   int ToneGen(int16 *ToneBuf,int Samples);
   int ToneGenSetup(char *pToneGenSpec = NULL,char **cp = NULL);

public:
   CToneGen *Link;
   int ID;

private:
   int GenSamples(int16 *ToneBuf,int Samples);
   char *TestCwString(char *CwString,char **pErrPos);
   int GenCW(int16 *CwBuf,int Samples);
   int GenDtmfSamples(int16 *ToneBuf,int Samples);
   char *TestDtmfString(char *DtmfString,char **pErrPos);
   char *TestFile(char *Path,char **pErrPos);
   int GenFileSamples(int16 *ToneBuf,int Samples);

private:
   int bToneGenActive;
   char *pToneGenSpecStart;
   char *pToneGen;
   char *pToneGenLastRep;
   int Tone1Freq;
   int Tone1EndFreq;
   int Tone1Level;
   int Tone2Freq;
   int Tone2Level;
   int ToneDuration;    // in milliseconds
   int Pause;
   int ToneRepCount;
   int wpm;
   double Tone1Angle;
   double DeltaAngle1;
   double DeltaAngle1Delta;
   double Tone2Angle;
   double DeltaAngle2;
   int ToneBufNum;
   int ToneGenSamples;
   int16 LastToneSample;
   int ElementCount;
   int b8BitFile;
   int RampCount;
   char *Element;
   int DitSamples;
   int CwRampCount;     // number of samples ramping up and down from full level
   char *ToneChar;
   FILE *fp;
   int bGenDtmf:1;
   int bGenCW:1;
   int bToneOn:1;
   int bElementSpace:1;
   int bFromFile:1;
};

FILE *OpenWaveFile(char *Filename,int *b8BitFile);

#endif

